import { select, range, symbol, symbols } from "d3";

const width = window.innerWidth;
const height = window.innerHeight;

const svg = select('body')
	.append('svg')
    .attr("width", width)
    .attr("height", height);

svg
	.append('g')
  .selectAll('rect')
  .data(range(100))
  .join('rect')
    .attr('y', (d) => d * 20)
    .attr('width', width)
    .attr('height', 10)
    .attr('mask', "url(#mask1)")

svg
	.append('g')
  .selectAll('rect')
  .data(range(100))
  .join('rect')
    .attr('x', (d) => d * 20)
    .attr('width', 10)
    .attr('height', height)
    .attr('mask', "url(#mask2)")

svg
  .call(renderMask, 'mask1', 'black')
	.call(renderMask, 'mask2', 'white')

function renderMask(selection, id, fill) {
	const mask = selection.append('mask').attr('id', id)
  
  mask
  	.append('rect')
      .attr('width', width)
      .attr('height', height)
      .attr('fill', fill === 'white' ? 'black' : 'white')
  
   mask
    .selectAll('g')
    .data(range(symbols.length))
    .join((enter) =>
      enter
        .append('g')
        .attr(
          'transform',
          (d) => `translate(${d * 125 + 100},${height - 90})`
        )
        .append('path')
        .attr('d', (d) => symbol(symbols[d], 8000)())
        .attr('fill', fill)
    );
}














